program moeb3_2;

{
  Fita de Mobius-Escher
}
uses PointOp,ListOp;

var f: text;

    P1,P2,P3,P4: tPoint;
    L1,L2: tPointPtr;
    s30,c30: real;

procedure WrBicubic(L: tPointPtr);
begin
  writeln(f,'  bicubic_patch{');
  writeln(f,'       type 1 flatness 0.01 u_steps 4 v_steps 4');
  while L <> nil do with L^ do
    begin write(f,'       ,'); WrPoint(f); writeln(f); L:= next end;
  writeln(f,'  }');
end;

begin
  s30:=sin(30*2*Pi/360); c30:=cos(30*2*PI/360);
  assign(f,'moeb3_2.inc'); rewrite(f);
  L1:=nil;
  lInsertNewPoint(L1,4.0,4.0*c30,0);
  lInsertNewPoint(L1,3.5,3.5*c30,0);
  lInsertNewPoint(L1,3.5,3.5*c30,0);
  lInsertNewPoint(L1,3.0,3.0*c30,0);

  lInsertNewPoint(L1,3.0*c30,5,2.0);
  lInsertNewPoint(L1,2.0*c30,5,2.0);
  lInsertNewPoint(L1,2.0*c30,5,2.0);
  lInsertNewPoint(L1,1.0*c30,5,2.0);

  lInsertNewPoint(L1,3.0*c30,5,-2.0);
  lInsertNewPoint(L1,2.0*c30,5,-2.0);
  lInsertNewPoint(L1,2.0*c30,5,-2.0);
  lInsertNewPoint(L1,1.0*c30,5,-2.0);

  lInsertNewPoint(L1,-1.0,1.0*c30,0);
  lInsertNewPoint(L1,-1.5,1.5*c30,0);
  lInsertNewPoint(L1,-1.5,1.5*c30,0);
  lInsertNewPoint(L1,-2.0,2.0*c30,0);
  WrBicubic(L1);
  lZRotate(L1,120);
  WrBicubic(L1);
  lZRotate(L1,120);
  WrBicubic(L1);
  L2:=nil;
  lInsertNewPoint(L2,-4.0,4.0*c30,0);
  lInsertNewPoint(L2,-3.5,3.5*c30,0);
  lInsertNewPoint(L2,-3.5,3.5*c30,0);
  lInsertNewPoint(L2,-3.0,3.0*c30,0);

  lInsertNewPoint(L2,-3.0*c30,5,-2.0);
  lInsertNewPoint(L2,-2.0*c30,5,-2.0);
  lInsertNewPoint(L2,-2.0*c30,5,-2.0);
  lInsertNewPoint(L2,-1.0*c30,5,-2.0);

  lInsertNewPoint(L2,-3.0*c30,5,2.0);
  lInsertNewPoint(L2,-2.0*c30,5,2.0);
  lInsertNewPoint(L2,-2.0*c30,5,2.0);
  lInsertNewPoint(L2,-1.0*c30,5,2.0);

  lInsertNewPoint(L2,1.0,1.0*c30,0);
  lInsertNewPoint(L2,1.5,1.5*c30,0);
  lInsertNewPoint(L2,1.5,1.5*c30,0);
  lInsertNewPoint(L2,2.0,2.0*c30,0);
  WrBicubic(L2);
  lZRotate(L2,120);
  WrBicubic(L2);
  lZRotate(L2,120);
  WrBicubic(L2);
  close(f)
end.

