program moeb3_2;

{
  Fita de Mobius-Escher
}
uses PointOp,ListOp;

var f: text;

    P1,P2,P3,P4: tPoint;
    L1,L2: tPointPtr;
    s30,c30: real;
    ax1,ay1,ax2,ay2,ax3,ay3,ax4,ay4: real;
    bx1,by1,bx2,by2,bx3,by3,bx4,by4: real;
    z0,y0,xx0,xx1: real;

procedure WrBicubic(L: tPointPtr);
begin
  writeln(f,'  bicubic_patch{');
  writeln(f,'       type 1 flatness 0.01 u_steps 4 v_steps 4');
  while L <> nil do with L^ do
    begin write(f,'       ,'); WrPoint(f); writeln(f); L:= next end;
  writeln(f,'  }');
end;

begin
  s30:=sin(45*2*Pi/360); c30:=cos(45*2*PI/360);
  ax1:=5.0*c30; ay1:=5.0*s30;
  ax2:=4.6*c30; ay2:=4.6*s30;
  ax3:=4.3*c30; ay3:=4.3*s30;
  ax4:=3.5*c30; ay4:=3.5*s30;

  bx1:=2.3*c30; by1:=2.3*s30;
  bx2:=2.3*c30; by2:=2.3*s30;
  bx3:=2.6*c30; by3:=2.6*s30;
  bx4:=3.0*c30; by4:=3.0*s30;

  z0:=4.0; y0:=5.0;
  xx0:=2.0*c30; xx1:=2.0*c30/3.0;

  assign(f,'moeb4_2.inc'); rewrite(f);
  L1:=nil;
  lInsertNewPoint(L1,ax1,ay1,0);
  lInsertNewPoint(L1,ax2,ay2,0);
  lInsertNewPoint(L1,ax3,ay3,0);
  lInsertNewPoint(L1,ax4,ay4,0);

  lInsertNewPoint(L1,xx0,y0,z0);
  lInsertNewPoint(L1,xx0,y0,z0);
  lInsertNewPoint(L1,xx0,y0,z0);
  lInsertNewPoint(L1,xx1,y0,z0);

  lInsertNewPoint(L1,xx0,y0,-z0);
  lInsertNewPoint(L1,xx0,y0,-z0);
  lInsertNewPoint(L1,xx0,y0,-z0);
  lInsertNewPoint(L1,xx1,y0,-z0);

  lInsertNewPoint(L1,-bx1,by1,0);
  lInsertNewPoint(L1,-bx2,by2,0);
  lInsertNewPoint(L1,-bx3,by3,0);
  lInsertNewPoint(L1,-bx4,by4,0);
  WrBicubic(L1);
  lZRotate(L1,90);
  WrBicubic(L1);
  lZRotate(L1,90);
  WrBicubic(L1);
  lZRotate(L1,90);
  WrBicubic(L1);
  L2:=nil;
  lInsertNewPoint(L2,-ax1,ay1,0);
  lInsertNewPoint(L2,-ax2,ay2,0);
  lInsertNewPoint(L2,-ax3,ay3,0);
  lInsertNewPoint(L2,-ax4,ay4,0);

  lInsertNewPoint(L2,-xx0,y0,-z0);
  lInsertNewPoint(L2,-xx0,y0,-z0);
  lInsertNewPoint(L2,-xx0,y0,-z0);
  lInsertNewPoint(L2,-xx1,y0,-z0);

  lInsertNewPoint(L2,-xx0,y0,z0);
  lInsertNewPoint(L2,-xx0,y0,z0);
  lInsertNewPoint(L2,-xx0,y0,z0);
  lInsertNewPoint(L2,-xx1,y0,z0);

  lInsertNewPoint(L2,bx1,by1,0);
  lInsertNewPoint(L2,bx2,by2,0);
  lInsertNewPoint(L2,bx3,by3,0);
  lInsertNewPoint(L2,bx4,by4,0);
  WrBicubic(L2);
  lZRotate(L2,90);
  WrBicubic(L2);
  lZRotate(L2,90);
  WrBicubic(L2);
  lZRotate(L2,90);
  WrBicubic(L2);
  close(f)
end.

