program moeb5_2b;

{
  Fita de Mobius-Escher
}
uses PointOp,ListOp;

var f: text;

    P1,P2,P3,P4: tPoint;
    L1,L2: tPointPtr;
    s30,c30: real;

procedure WrBicubic(L: tPointPtr);
begin
  writeln(f,'  bicubic_patch{');
  writeln(f,'       type 1 flatness 0.01 u_steps 4 v_steps 4');
  while L <> nil do with L^ do
    begin write(f,'       ,'); WrPoint(f); writeln(f); L:= next end;
  writeln(f,'  }');
end;

begin
  s30:=sin(18*2*Pi/360); c30:=cos(18*2*PI/360);
  assign(f,'moeb5_2b.inc'); rewrite(f);
  L1:=nil;
  lInsertNewPoint(L1,4.0*c30,4.0*s30,0);
  lInsertNewPoint(L1,3.5*c30,3.5*s30,0);
  lInsertNewPoint(L1,3.5*c30,3.5*s30,0);
  lInsertNewPoint(L1,3.0*c30,3.0*s30,0);

  lInsertNewPoint(L1,1.7*c30,7,2.0);
  lInsertNewPoint(L1,1.5*c30,7,2.0);
  lInsertNewPoint(L1,1.0*c30,7,2.0);
  lInsertNewPoint(L1,0.5*c30,7,2.0);

  lInsertNewPoint(L1,1.7*c30,7,-2.0);
  lInsertNewPoint(L1,1.5*c30,7,-2.0);
  lInsertNewPoint(L1,1.0*c30,7,-2.0);
  lInsertNewPoint(L1,0.5*c30,7,-2.0);

  lInsertNewPoint(L1,-1.0*c30,1.0*s30,0);
  lInsertNewPoint(L1,-1.5*c30,1.5*s30,0);
  lInsertNewPoint(L1,-1.5*c30,1.5*s30,0);
  lInsertNewPoint(L1,-2.0*c30,2.0*s30,0);
  WrBicubic(L1);
(**)
  lZRotate(L1,144);
  WrBicubic(L1);
  lZRotate(L1,144);
  WrBicubic(L1);
  lZRotate(L1,144);
  WrBicubic(L1);
  lZRotate(L1,144);
  WrBicubic(L1);
(**)
  L2:=nil;
  lInsertNewPoint(L2,-4.0*c30,4.0*s30,0);
  lInsertNewPoint(L2,-3.5*c30,3.5*s30,0);
  lInsertNewPoint(L2,-3.5*c30,3.5*s30,0);
  lInsertNewPoint(L2,-3.0*c30,3.0*s30,0);

  lInsertNewPoint(L2,-1.7*c30,7,-2.0);
  lInsertNewPoint(L2,-1.5*c30,7,-2.0);
  lInsertNewPoint(L2,-1.0*c30,7,-2.0);
  lInsertNewPoint(L2,-0.5*c30,7,-2.0);

  lInsertNewPoint(L2,-1.7*c30,7,2.0);
  lInsertNewPoint(L2,-1.5*c30,7,2.0);
  lInsertNewPoint(L2,-1.0*c30,7,2.0);
  lInsertNewPoint(L2,-0.5*c30,7,2.0);

  lInsertNewPoint(L2,1.0*c30,1.0*s30,0);
  lInsertNewPoint(L2,1.5*c30,1.5*s30,0);
  lInsertNewPoint(L2,1.5*c30,1.5*s30,0);
  lInsertNewPoint(L2,2.0*c30,2.0*s30,0);
  WrBicubic(L2);
(**)
  lZRotate(L2,144);
  WrBicubic(L2);
  lZRotate(L2,144);
  WrBicubic(L2);
  lZRotate(L2,144);
  WrBicubic(L2);
  lZRotate(L2,144);
  WrBicubic(L2);
(**)
  close(f)
end.

