program no_b;

{
  Constroi um "no' de cilindros"
}
uses PointOp,ListOp;
var f: text;

{$F+ }
procedure WrSph(P: tPoint);
begin
  with P.C do writeln(f,'sphere{ <',x:7:3,',',y:7:3,',',z:7:3,'> .8  1 pigment {Pink} }');
end;

procedure WrSpheres(L:tPointPtr);
begin
  NPassos(L,30,WrSph,f);
end;

procedure WrBolas(L:tPointPtr);
var L1,L2: tPointPtr;
begin
  assign(f,'no_b.inc'); rewrite(f);
  L1:=lCopy(L); lXRotate(L1,90); lZRotate(L1,90);
  L2:=lCopy(L); lXRotate(L2,90); lZRotate(L2,90);
  writeln(f,'#declare no3 = blob {');
  { writeln(f,'                  #declare r =',r:7:3); }
  writeln(f,'                  threshold 1.0');
  writeln(f,'// ****** Lista das esferas ');
  WrSpheres(L);
  WrSpheres(L1);
  WrSpheres(L2);
  writeln(f,'      finish { phong 1 }');
  writeln(f,'// ***********************');
  writeln(f,'}');
  close(f);
end;


(***********************************************************)

procedure FazNo;
const a:real=1.0; { largura do cubo }
      k: real=8; { distancia para os pontos de controle }
      n: integer = 128;
var L1,L2: tPointPtr;
begin
  L1:=nil;
  { insere em L1 os 4 pontos de controle, criados a partir de um cubo }
  lInsertNewPoint(L1,-a,a,0);
  lInsertNewPoint(L1,-a,a,k);
  lInsertNewPoint(L1,a,-k,-a);
  lInsertNewPoint(L1,a, 0,-a);
  { lWrList(L1); readln; }
  L2:=Bezier(L1, n);
  { lWrList(L2); readln; }
  WrBolas(L2)
end;


begin { main }
  FazNo;
end.

