program no_q;

{
  Constroi um "no de Escher" de seccao Quadrada,
  usando superficies de Bezier.
}
uses PointOp,ListOp;
var OldP: tPoint;

procedure FazNo;
const a:real=1.0; { largura do cubo }
      q:real=0.95; { lado do quadrado }
      k: real=7; { distancia para os pontos de controle }
var L,Laux: tPointPtr;
   

  function ListaDeQuatro(dx,dy: real): tPointPtr;
  var L:tPointPtr;  P1,P2,P3,P4: tPoint;
  begin
    P1.NewPoint(a+dx,-a+dy,0);
    P2.NewPoint(a+dx,-a+dy,k-2*dy);
    P3.NewPoint(a+dx,-a+dy,-k+2*dy); P3.zRotate(90); P3.yRotate(-90);
    P4.NewPoint(a+dx,-a+dy, 0); P4.zRotate(90); P4.yRotate(-90);
    L:=nil;
    with P1.C do lInsertNewPoint(L,x,y,z);
    with P2.C do lInsertNewPoint(L,x,y,z);
    with P3.C do lInsertNewPoint(L,x,y,z);
    with P4.C do lInsertNewPoint(L,x,y,z);
    ListaDeQuatro:=L
  end;

  procedure Lista(var f: text; L: tPointPtr);
  begin
    writeln(f,'bicubic_patch {');
    writeln(f,'               type 1 flatness 0.01 u_steps 8 v_steps 8,');
    while L<>nil do with L^ do
      begin
        write(f,'              '); WrPoint(f); writeln(f); L:=next
      end;
   writeln(f,'              }');
  end;
var f: text;
begin { FazNo }
  assign(f,'no_qa.inc'); rewrite(f);
  L:=nil;
  Laux:=ListaDeQuatro(     0,0); lAppend(L,Laux);
  Laux:=ListaDeQuatro(  -q/3,0); lAppend(L,Laux);
  Laux:=ListaDeQuatro(-2*q/3,0); lAppend(L,Laux);
  Laux:=ListaDeQuatro(    -q,0); lAppend(L,Laux);
  Lista(f,L);

  L:=nil;
  Laux:=ListaDeQuatro(     0,q); lAppend(L,Laux);
  Laux:=ListaDeQuatro(  -q/3,q); lAppend(L,Laux);
  Laux:=ListaDeQuatro(-2*q/3,q); lAppend(L,Laux);
  Laux:=ListaDeQuatro(    -q,q); lAppend(L,Laux);
  Lista(f,L);
  close(f);
end;


begin { main }
  FazNo;
end.

